<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>Classwork Array</title>
    <div id="array-exmpl">

    </div>
    <div>
      <input type="text" id="search-input"/>
      <button id="search-btn">Поиск</button>
      <ul id="search-result"></ul>
    </div>
    <div>
      <select id="select-star"></select>
      <input type="text" id="movies-input" placeholder="duration"/>
      <button id="movies-btn">Поиск</button>
      <ul id="movies-result"></ul>
    </div>
    <script>

    /*
      Задание:
      1. При помощи методов изложеных ниже, переформатировать ITEA_COURSES в массив который содержит длину строк каждого из элементов.
      2. Самостоятельно изучить метод Array.sort. Отфильтровать массив ITEA_COURSES по алфавиту.
          + Бонусный бал. Вывести на страничку списком
      3. Реализация функции поиска по массиву ITEA_COURSES.
          + Бонусный бал. Вывести на страничку инпут и кнопку по которой будет срабатывать поиск.
    */
    let array_exmpl = document.getElementById('array-exmpl');
    
      const ITEA_COURSES = ["Курс HTML & CSS", "JavaScript базовый курс", "JavaScript продвинутый курс", "JavaScript Professional", "Angular 2.4 (базовый)", "Angular 2.4 (продвинутый)", "React.js", "React Native", "Node.js", "Vue.js"];
      const ITEA_COURSES_LENGTH = ITEA_COURSES.map(x=>x.length);
      array_exmpl.innerHTML = 'масив длин:<br />' + ITEA_COURSES_LENGTH.join(', ') + '<br /><br />'

      const ITEA_COURSES_SORT = ITEA_COURSES.sort(function (a, b) {
          return a.localeCompare(b);
      });
      array_exmpl.innerHTML +='отсортированый массив:<ul>' + ITEA_COURSES_SORT.map(x=>`<li>${x}</li>`).join('') + '</ul>';

      const search_input = document.getElementById('search-input');
      const search_btn = document.getElementById('search-btn');
      const search_result = document.getElementById('search-result');

      search_btn.addEventListener('click', () => {
        search_result.innerHTML = ITEA_COURSES_SORT
          .filter(x=>x.toLowerCase().includes(search_input.value.toLowerCase()))
          .map(x=>`<li>${x}</li>`).join('');
      });

    /*
      Задание 2:
      Написать фильтр массива по:
      Актеру, продолжительности

      Бонус:
        Сделать графическую оболочку для программы:
        - Селект со списком актеров
        - Селект или инпут с продолжительностью
        - Результат в виде списка фильмов
    */


      var stars = ['Elijah Wood', 'Ian McKellen', 'Orlando Bloom','Ewan McGregor',' Liam Neeson', 'Natalie Portman', 'Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
      var movies = [
          {
            name: "Lord of the Rigs",
            duration: 240,
            starring: [ 'Elijah Wood', 'Ian McKellen', 'Orlando Bloom']
          },
          {
            name: "Star Wars: Episode I - The Phantom Menace",
            duration: 136,
            starring: [ 'Ewan McGregor',' Liam Neeson', 'Natalie Portman']
          },
          {
            name: "Fargo",
            duration: 100,
            starring: [ 'Ewan McGregor', 'Billy Bob Thornton', 'Martin Freeman']
          },
          {
          name: "V for Vendetta",
          duration: 150,
          starring: [ 'Hugo Weaving', 'Natalie Portman', 'Rupert Graves']
        }
        ];

        let select_star = document.getElementById('select-star');
        stars.forEach(element => {
          let option = new Option(element, element);
          select_star.appendChild(option);
        });
        const movies_input = document.getElementById('movies-input');
        const movies_btn = document.getElementById('movies-btn');
        const movies_result = document.getElementById('movies-result');

         movies_btn.addEventListener('click', () => {
          movies_result.innerHTML = movies
          //.filter(x=>x.duration<=Number(movies_input.value||1000)) 
          .filter(y=>y.starring.some(function(elem){ return elem===select_star.value; }))
          .map(x=>`<li>${x.name} [${x.duration} min]</li>`).join('');
      });

    </script>
</head>
<body>

</body>
</html>
